#pragma once

#include <KSGNetwork.h>
#include <Punkt.h>
#include <Critical.h>

namespace Editor
{
    struct TeamDaten;
    struct SpielerDaten;
    struct BariereDaten;
    struct BaseDaten;
    struct DropDaten;
    struct SchalterDaten;
    struct SchieneDaten;
    struct TimerDaten;
    struct TunnelDaten;
    struct UmlenkungDaten;
    struct TriggerDaten;
    struct VariableDaten;

    class SpielerTeamStruktur : public SpielerTeamStrukturV
    {
    public:
        SpielerTeamStruktur();
        ~SpielerTeamStruktur();
        SpielerTeamStrukturV *getThis() override;
        SpielerTeamStrukturV *release() override;
    };

    class EditorKlient : public virtual ReferenceCounter
    {
    private:
        KSGClient::EditorServerClient *klient;
        Text error;
        Critical cs;

    public:
        // Konstruktor
        //  k: Der zu verwendende Klient
        EditorKlient( KSGClient::EditorServerClient *k );
        // Destruktor
        ~EditorKlient();
        // Initialisiert den Server
        //  return: 1, falls erfolgreich
        //          2, falls bereits eine Sitzung existiert
        //          0, sonnst
        int init();
        // Verwirft die vorhandene Sitzung und erstellt eine neue
        bool sitzungVerwerfen();
        // Speichert Sitzung und beendet Editor
        bool sitzungBeenden();
        // Ldt die Spieler Team Struktur
        bool getSpielerTeamStruktur( SpielerTeamStrukturV *zSts );
        bool loadMapSize( Punkt &size );
        bool loadSpieler( Array< SpielerDaten * > &spieler );
        bool loadTeams( Array< TeamDaten * > &teams );
        bool loadBarieren( Array< BariereDaten * > &barieren );
        bool loadBasen( Array< BaseDaten * > &basen );
        bool loadDrops( Array< DropDaten * > &drops );
        bool loadSchalter( Array< SchalterDaten * > &schalter );
        bool loadSchienen( Array< SchieneDaten * > &schienen );
        bool loadTimer( Array< TimerDaten * > &timer );
        bool loadTunnel( Array< TunnelDaten * > &tunnel );
        bool loadUmlenkung( Array< UmlenkungDaten * > &umlenkung );
        bool loadTrigger( Array< TriggerDaten * > &trigger );
        bool loadVariable( Array< VariableDaten * > &variable );
        bool saveMapSize( Punkt size );
        bool saveTeam( const TeamDaten *team );
        bool saveSpieler( const SpielerDaten *spieler );
        bool saveBariere( const BariereDaten *bariere );
        bool saveBase( const BaseDaten *base );
        bool saveDrop( const DropDaten *drop );
        bool saveSchalter( const SchalterDaten *schalter );
        bool saveSchiene( const SchieneDaten *schiene );
        bool saveTimer( const TimerDaten *timer );
        bool saveTunnel( const TunnelDaten *tunnel );
        bool saveUmlenkung( const UmlenkungDaten *umlenkung );
        bool saveTrigger( const TriggerDaten *trigger );
        bool saveVariable( const VariableDaten *variable );
        bool deleteBariere( int id );
        bool deleteBase( int id );
        bool deleteDrop( int id );
        bool deleteSchalter( int id );
        bool deleteSchiene( int id );
        bool deleteTimer( int id );
        bool deleteTunnel( int id );
        bool deleteUmlenkung( int id );
        bool deleteTrigger( int id );
        bool deleteVariable( int id );
        // Gibt den Letzten Fehler zurck
        char *getLastError() const;
    };
}