#include "EncryptedNetworkReader.h"
#include <stdexcept>

using namespace Editor;

class NotImplementedException : public std::logic_error
{
public:
    NotImplementedException() : std::logic_error{ "Function not implemented." } {}
};

EncryptedNetworkReader::EncryptedNetworkReader( Network::Klient *k )
{
    this->k = k;
}

EncryptedNetworkReader::~EncryptedNetworkReader()
{
    if( k )
        k->release();
}

//! Setzt die Position des Bytes, das als nchstes gelesen werden soll
//! \param pos Der Index des Bytes
//! \param ende 1, wenn der Index vom ende der Resource zhlt. 0, wenn der Index vom Beginn der Resource zhlt
void EncryptedNetworkReader::setLPosition( __int64 pos, bool ende )
{
    throw NotImplementedException();
}

//! Liet aus der Datei
//! \param bytes Ein Array, der mit Bytes aus der Resource gefllt werden soll
//! \param len Wie viele Bytes aus der Resource gelesen werden sollen
void EncryptedNetworkReader::lese( char *bytes, int len )
{
    k->getNachrichtEncrypted( bytes, len );
}

//! Liet die nchste zeile der Resource ein
//! \return Die gelesene Zeile als Text mit zeilenumbruch
Text *EncryptedNetworkReader::leseZeile()
{
    throw NotImplementedException();
}

//! Prft, ob die Resource vollstndig gelesen wurde
//!  return 1, wenn die Resource vollstndig gelesen wurde. 0, sonst
bool EncryptedNetworkReader::istEnde() const
{
    return false;
}

//! Gibt den Index des Bytes aus der Resource zurck, welches als nchstes gelesen werden wrde
//! return -1, falls ein Fehler aufgetreten ist. Sonst die Position des Lesezeigers
__int64 EncryptedNetworkReader::getLPosition() const
{
    throw NotImplementedException();
}
