#pragma once
#include <Klient.h>
#include <Reader.h>

namespace Editor
{
    class EncryptedNetworkReader : public Reader
    {
    private:
        Network::Klient *k;

    public:
        EncryptedNetworkReader( Network::Klient *k );
        ~EncryptedNetworkReader();
        //! Setzt die Position des Bytes, das als nchstes gelesen werden soll
        //! \param pos Der Index des Bytes
        //! \param ende 1, wenn der Index vom ende der Resource zhlt. 0, wenn der Index vom Beginn der Resource zhlt
        void setLPosition( __int64 pos, bool ende ) override;
        //! Liet aus der Datei
        //! \param bytes Ein Array, der mit Bytes aus der Resource gefllt werden soll
        //! \param len Wie viele Bytes aus der Resource gelesen werden sollen
        void lese( char *bytes, int len ) override;
        //! Liet die nchste zeile der Resource ein
        //! \return Die gelesene Zeile als Text mit zeilenumbruch
        Text *leseZeile() override;
        //! Prft, ob die Resource vollstndig gelesen wurde
        //!  return 1, wenn die Resource vollstndig gelesen wurde. 0, sonst
        bool istEnde() const override;
        //! Gibt den Index des Bytes aus der Resource zurck, welches als nchstes gelesen werden wrde
        //! return -1, falls ein Fehler aufgetreten ist. Sonst die Position des Lesezeigers
        __int64 getLPosition() const override;
    };
}